VERSION 5.00
Object = "{5E9E78A0-531B-11CF-91F6-C2863C385E30}#1.0#0"; "Msflxgrd.ocx"
Begin VB.Form form_Table 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Hp, Mp & Exp Table"
   ClientHeight    =   5190
   ClientLeft      =   45
   ClientTop       =   615
   ClientWidth     =   4470
   Icon            =   "form_Table.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   5190
   ScaleWidth      =   4470
   StartUpPosition =   2  'CenterScreen
   Begin VB.TextBox txtEdit 
      Height          =   285
      Left            =   1200
      MaxLength       =   8
      TabIndex        =   1
      Text            =   "txtEdit"
      Top             =   480
      Visible         =   0   'False
      Width           =   975
   End
   Begin MSFlexGridLib.MSFlexGrid Table 
      Height          =   4935
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   4215
      _ExtentX        =   7435
      _ExtentY        =   8705
      _Version        =   393216
      Rows            =   100
      Cols            =   4
      AllowBigSelection=   0   'False
      AllowUserResizing=   1
   End
   Begin VB.Menu menu_File 
      Caption         =   "&File"
      Begin VB.Menu menu_Save 
         Caption         =   "Save"
         Shortcut        =   ^S
      End
      Begin VB.Menu menu_Print 
         Caption         =   "Dum&p"
         Shortcut        =   ^P
      End
   End
   Begin VB.Menu menu_Help 
      Caption         =   "&Help"
      Begin VB.Menu menu_Notes 
         Caption         =   "&Notes"
      End
   End
End
Attribute VB_Name = "form_Table"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Option Base 1

Dim i As Integer
Dim j As Integer
Dim FF As Long
Dim CurVal As Byte
Dim Bit(4) As Long
Dim Result As Long

Private Sub Form_Load()
' -----------------------------------------------------------------------------
'
' -----------------------------------------------------------------------------
    Table.TextMatrix(0, 0) = "Level"
    Table.TextMatrix(0, 1) = "Hp"
    Table.TextMatrix(0, 2) = "Mp"
    Table.TextMatrix(0, 3) = "Exp"
    
    For i = 1 To 99
        Table.TextMatrix(i, 0) = i
    Next
    
    Call LoadData(form_Main.CD_Load.FileName)
   
End Sub

Private Sub LoadData(pfile As String)
' -----------------------------------------------------------------------------
'
' -----------------------------------------------------------------------------
    ' The variable FF is equal to the next available file number
    FF = freefile
     
    Open pfile For Binary As #FF
    
        ' ==================================================
        ' Load the Experience (3 bytes)
        ' ==================================================
        For j = 0 To 98
            Get #FF, &H115000 + 1 + (j * 3) + Header, CurVal
            Bit(1) = CurVal
            Get #FF, &H115001 + 1 + (j * 3) + Header, CurVal
            Bit(2) = CurVal
            Get #FF, &H115002 + 1 + (j * 3) + Header, CurVal
            Bit(3) = CurVal
            
            Result = (Bit(3) * 65536) + (Bit(2) * 256) + Bit(1)
            Table.TextMatrix(j + 1, 3) = Result
        Next
        
        ' ==================================================
        ' Load the Hp (2 bytes)
        ' ==================================================
        For j = 0 To 98
            Get #FF, &H115129 + 1 + (j * 2) + Header, CurVal
            Bit(1) = CurVal
            Get #FF, &H11512A + 1 + (j * 2) + Header, CurVal
            Bit(2) = CurVal
            
            Result = (Bit(2) * 256) + Bit(1)
            Table.TextMatrix(j + 1, 1) = Result
        Next
        
        ' ==================================================
        ' Load the Mp (2 bytes)
        ' ==================================================
        For j = 0 To 98
            Get #FF, &H1151EF + 1 + (j * 2) + Header, CurVal
            Bit(1) = CurVal
            Get #FF, &H1151F0 + 1 + (j * 2) + Header, CurVal
            Bit(2) = CurVal
            
            Result = (Bit(2) * 256) + Bit(1)
            Table.TextMatrix(j + 1, 2) = Result
        Next

    Close #FF

End Sub

Private Sub Form_Unload(Cancel As Integer)
' -----------------------------------------------------------------------------
'
' -----------------------------------------------------------------------------
    form_Main.Show
    
End Sub

Private Sub GridEdit(KeyAscii As Integer)
' -----------------------------------------------------------------------------
'
' -----------------------------------------------------------------------------
    ' Position the TextBox over the cell.
    
    txtEdit.Left = Table.CellLeft + Table.Left
    txtEdit.Top = Table.CellTop + Table.Top
    txtEdit.Width = Table.CellWidth
    txtEdit.Height = Table.CellHeight
    txtEdit.Visible = True
    txtEdit.SetFocus
    
    Select Case KeyAscii
        Case 0 To Asc(" ")
            txtEdit.Text = Table.Text
            txtEdit.SelStart = Len(txtEdit.Text)
        Case Else
            txtEdit.Text = Chr$(KeyAscii)
            txtEdit.SelStart = 1
    End Select

End Sub

Private Sub menu_Notes_Click()
' -----------------------------------------------------------------------------
'
' -----------------------------------------------------------------------------
    MsgBox ("The Hp & Mp values on the list are BASE values." _
    & vbCrLf & "If you want to calculate the ACTUAL values then:" _
    & vbCrLf & vbCrLf & "HP = (Base HP * (Vitality+32)) / 32" _
    & vbCrLf & "MP = (Base MP * (Magic Power+32)) / 32" _
    & vbCrLf & vbCrLf & "Bonuses to Vitality or Magic Power due to equipment are not added.")
    
End Sub

Private Sub menu_Print_Click()
' -----------------------------------------------------------------------------
'
' -----------------------------------------------------------------------------
    'Print
    Dim level As Long
    Dim hp As Long
    Dim mp As Long
    Dim exp As Long
    
    form_Main.CD_Save.ShowSave
    If form_Main.CD_Save.FileName = "" Then Exit Sub
    
    Open form_Main.CD_Save.FileName For Output As #1
    
        For i = 1 To 99
            level = Table.TextMatrix(i, 0)
            hp = Table.TextMatrix(i, 1)
            mp = Table.TextMatrix(i, 2)
            exp = Table.TextMatrix(i, 3)
        
            Print #1, "Level: " & Space(8 - Len(Str(level))) & level
            Print #1, "   Hp: " & Space(8 - Len(Str(hp))) & hp
            Print #1, "   Mp: " & Space(8 - Len(Str(mp))) & mp
            Print #1, "  Exp: " & Space(8 - Len(Str(exp))) & exp
            Print #1, ""
        Next i
    
    Close #1
    
    MsgBox "The text file has been generated", vbOKOnly, App.ProductName
    
End Sub

Private Sub menu_Save_Click()
' -----------------------------------------------------------------------------
'
' -----------------------------------------------------------------------------
    Call SaveTable(form_Main.CD_Load.FileName)

    MsgBox "The table has been saved", vbOKOnly, App.ProductName

End Sub

Public Sub SaveTable(pfile As String)
' -----------------------------------------------------------------------------
'
' -----------------------------------------------------------------------------
    ' Get the next available file number
    FF = freefile
    
    Open pfile For Binary As #FF
    
        ' ==================================================
        ' Save the Experience
        ' ==================================================
        For j = 0 To 98
            Bit(1) = (Table.TextMatrix(j + 1, 3) And &H100000FF)
            Bit(2) = (Table.TextMatrix(j + 1, 3) And &H1000FF00) \ &H100
            Bit(3) = (Table.TextMatrix(j + 1, 3) And &H10FF0000) \ &H10000
        
            Put #FF, &H115000 + 1 + (j * 3) + Header, CByte(Bit(1))
            Put #FF, &H115001 + 1 + (j * 3) + Header, CByte(Bit(2))
            Put #FF, &H115002 + 1 + (j * 3) + Header, CByte(Bit(3))
        Next
        ' ==================================================
        ' Load the Hp
        ' ==================================================
        For j = 0 To 98
            Call SaveInt(&H115129 + 1 + (j * 2) + Header, Table.TextMatrix(j + 1, 1), pfile)
        Next
        ' ==================================================
        ' Load the Mp
        ' ==================================================
        For j = 0 To 98
            Call SaveInt(&H1151EF + 1 + (j * 2) + Header, Table.TextMatrix(j + 1, 2), pfile)
        Next
    
    Close #FF
    
End Sub

Private Sub Table_DblClick()
' -----------------------------------------------------------------------------
'
' -----------------------------------------------------------------------------
    GridEdit Asc(" ")
    
End Sub

Private Sub Table_GotFocus()
' -----------------------------------------------------------------------------
'
' -----------------------------------------------------------------------------
    If txtEdit.Visible Then
        Table.Text = txtEdit.Text
        txtEdit.Visible = False
    End If
    
End Sub

Private Sub Table_KeyPress(KeyAscii As Integer)
' -----------------------------------------------------------------------------
'
' -----------------------------------------------------------------------------
    GridEdit KeyAscii
    
End Sub

Private Sub Table_LeaveCell()
' -----------------------------------------------------------------------------
'
' -----------------------------------------------------------------------------
    If txtEdit.Visible Then
        Table.Text = txtEdit.Text
        txtEdit.Visible = False
    End If

End Sub

Private Sub txtEdit_KeyDown(KeyCode As Integer, Shift As Integer)
' -----------------------------------------------------------------------------
'
' -----------------------------------------------------------------------------
    Select Case KeyCode
        Case vbKeyEscape        ' Leave the text unchanged.
            txtEdit.Visible = False
            Table.SetFocus
        Case vbKeyReturn        ' Finish editing.
            Table.SetFocus
        Case vbKeyDown          ' Move down 1 row.
            Table.SetFocus
            DoEvents
            
            If Table.Row < Table.Rows - 1 Then
                Table.Row = Table.Row + 1
            End If

        Case vbKeyUp            ' Move up 1 row.
            Table.SetFocus
            DoEvents
            
            If Table.Row > Table.FixedRows Then
                Table.Row = Table.Row - 1
            End If

    End Select

End Sub

Private Sub txtEdit_KeyPress(KeyAscii As Integer)
' -----------------------------------------------------------------------------
'
' -----------------------------------------------------------------------------
    If (KeyAscii = vbKeyReturn) Or (KeyAscii = vbKeyEscape) Then KeyAscii = 0
            
End Sub
