Attribute VB_Name = "ModFunctions"
Option Explicit

    Global Header As Integer

Public Sub SaveInt(offset, value, Location)
' -----------------------------------------------------------------------------
'
' -----------------------------------------------------------------------------
    Dim sval As Byte
    Dim A, B, C
    
    A = Hex(value)
    If Len(A) = 1 Then A = "000" & A
    If Len(A) = 2 Then A = "00" & A
    If Len(A) = 3 Then A = "0" & A
    
    B = ConvertHex(Left(A, 2))
    C = ConvertHex(Right(A, 2))
    
    'Open Location For Binary As 1
        Put #1, offset, CByte(C)
        Put #1, offset - -1, CByte(B)
    'Close 1
    
End Sub

Function ConvertHex(h$) As Currency
' -----------------------------------------------------------------------------
'
' -----------------------------------------------------------------------------
    Dim Tmp$
    Dim lo1 As Integer, lo2 As Integer
    Dim hi1 As Long, hi2 As Long
    Const Hx = "&H"
    Const BigShift = 65536
    Const LilShift = 256, Two = 2
    
    Tmp = h
    'In case "&H" is present
    
    If UCase(Left$(h, 2)) = "&H" Then Tmp = Mid$(h, 3)
    'In case there are too few characters
    
    Tmp = Right$("0000000" & Tmp, 8)
    'In case it wasn't a valid number
    
    If IsNumeric(Hx & Tmp) Then
        lo1 = CInt(Hx & Right$(Tmp, Two))
        hi1 = CLng(Hx & Mid$(Tmp, 5, Two))
        lo2 = CInt(Hx & Mid$(Tmp, 3, Two))
        hi2 = CLng(Hx & Left$(Tmp, Two))
        ConvertHex = CCur(hi2 * LilShift + lo2) * BigShift + (hi1 * LilShift) + lo1
    End If
    
End Function

Public Function GetInteger(value)
' -----------------------------------------------------------------------------
'
' -----------------------------------------------------------------------------
    Dim A$
    
    A$ = Hex(value)
    
    If Len(A$) = 1 Then A$ = "000" & A$
    If Len(A$) = 2 Then A$ = "00" & A$
    If Len(A$) = 3 Then A$ = "0" & A$
    
    GetInteger = ConvertHex(A$)
    
End Function

Public Sub SaveHP(Offset1 As Long, Offset2 As Long, value As String, pfile As String)
' -----------------------------------------------------------------------------
'
' -----------------------------------------------------------------------------
    Dim Str1 As String
    Dim Str2 As String
    Dim Str3 As String
    
    Dim A, B, C
    
    Str1 = Hex(value)
    
    If Len(Str1) = 1 Then A = "000" & A
    If Len(Str1) = 2 Then A = "00" & A
    If Len(Str1) = 3 Then A = "0" & A

    Str2 = Left(Str1, 2)
    Str3 = Right(Str1, 2)

    'Open pfile For Binary As 1
        Put #1, Offset1, CByte(Str3)
        Put #1, Offset2, CByte(Str2)
    'Close 1
    
End Sub

Public Sub GetHeader(freefile)
' -----------------------------------------------------------------------------
'
' -----------------------------------------------------------------------------
    Dim length As Long

    length = LOF(freefile)
    Header = length Mod &H8000

End Sub
