VERSION 5.00
Begin VB.Form form_Enemy_AI 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Enemy AI"
   ClientHeight    =   7140
   ClientLeft      =   45
   ClientTop       =   615
   ClientWidth     =   4740
   Icon            =   "form_Enemy_AI.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   7140
   ScaleWidth      =   4740
   StartUpPosition =   2  'CenterScreen
   Begin VB.Frame Frame1 
      Height          =   6975
      Left            =   0
      TabIndex        =   0
      Top             =   120
      Width           =   4695
      Begin VB.Frame Frame21 
         Height          =   2415
         Left            =   240
         TabIndex        =   4
         ToolTipText     =   "Enemy Sprite"
         Top             =   4320
         Width           =   3255
         Begin VB.Image ImageEnemy 
            Height          =   2040
            Left            =   120
            ToolTipText     =   "Enemy Sprite"
            Top             =   240
            Width           =   3000
         End
      End
      Begin VB.TextBox txtNumber 
         Alignment       =   1  'Right Justify
         Enabled         =   0   'False
         Height          =   285
         Left            =   3600
         TabIndex        =   3
         Text            =   "N/A"
         ToolTipText     =   "Enemy Index"
         Top             =   240
         Width           =   735
      End
      Begin VB.ListBox ListAI 
         BeginProperty Font 
            Name            =   "Courier"
            Size            =   9.75
            Charset         =   0
            Weight          =   400
            Underline       =   0   'False
            Italic          =   0   'False
            Strikethrough   =   0   'False
         EndProperty
         Height          =   6105
         Left            =   3600
         TabIndex        =   2
         Top             =   600
         Width           =   735
      End
      Begin VB.ComboBox cbName 
         Height          =   4080
         Left            =   240
         Style           =   1  'Simple Combo
         TabIndex        =   1
         Text            =   "cbName"
         ToolTipText     =   "Enemy Name"
         Top             =   240
         Width           =   3255
      End
   End
   Begin VB.Menu menu_File 
      Caption         =   "&File"
      Begin VB.Menu menu_Print 
         Caption         =   "Dum&p"
         Shortcut        =   ^P
      End
   End
End
Attribute VB_Name = "form_Enemy_AI"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Option Base 1

Dim i As Long, j As Long, k As Long
Dim FF As Long, Address As Long
Dim Pointer(370) As Long
'Dim Value(10496) As Byte
Dim CurVal As Byte

Private Sub cbName_Click()
' -----------------------------------------------------------------------------
'
' -----------------------------------------------------------------------------
    ListAI.Clear
    txtNumber.Text = cbName.ListIndex + 1
    j = cbName.ListIndex + 1
    
    Set ImageEnemy.Picture = form_Main.ImageListEnemy.ListImages(j).Picture
    
    If j > 230 Then j = j - 1
    Call LoadMonster(form_Main.CD_Load.FileName)
    
End Sub

Private Sub Form_Load()
' -----------------------------------------------------------------------------
'
' -----------------------------------------------------------------------------
    AddEnemyToComboBox cbName
    Address = &H10A100
    
    Call LoadPointer(form_Main.CD_Load.FileName)
    j = 1
    Call LoadMonster(form_Main.CD_Load.FileName)
        
End Sub

Private Sub LoadPointer(pfile As String)
' -----------------------------------------------------------------------------
'
' -----------------------------------------------------------------------------
    ' The variable FF is equal to the next available file number
    FF = freefile
 
    Open pfile For Binary As #FF
    
    'From 10:A100 to 10:CA00 (1089792 - 1100288)
    
    Address = &H109F00 + 1 + Header
    Pointer(1) = Address
    i = 2
        
        Do While (Address < (1100089 + Header)) And (i < 370)
            j = 0
            Get #FF, Address + 1, CurVal
            Do While CurVal <> 255
                Get #FF, Address + 1, CurVal
                Address = Address + 1
            Loop
            
            Get #FF, Address + 1, CurVal
            
            Do While CurVal <> 255
                Get #FF, Address + 1, CurVal
                Address = Address + 1
                j = 1
            Loop
            
            Address = Address + 2 - j
            Pointer(i) = Address
            i = i + 1
        Loop

    Close #FF
    
End Sub

Private Sub LoadMonster(pfile As String)
' -----------------------------------------------------------------------------
'
' -----------------------------------------------------------------------------
    ' The variable FF is equal to the next available file number
    FF = freefile
     
    Open pfile For Binary As #FF
    
        ' ==================================================
        ' Load AI
        ' ==================================================
        Address = Pointer(j)
        
        For i = Pointer(j) To Pointer(j + 1) - 1
            Get #FF, Address, CurVal
            
            If Len(Hex(CurVal)) = 1 Then
                ListAI.AddItem Space(1) & "0" & Hex(CurVal)
            Else
                ListAI.AddItem Space(1) & Hex(CurVal)
            End If
            
            'ListAI.AddItem Space(2 - Len(Hex(CurVal))) & Hex(CurVal)
            Address = Address + 1
        Next i
        
    Close #FF

End Sub

Public Sub AddEnemyToComboBox(pCombobox As ComboBox)
' -----------------------------------------------------------------------------
'
' -----------------------------------------------------------------------------
    For i = 1 To Enemies.Count
        pCombobox.AddItem Enemies.Item(i)
    Next i
    
    pCombobox.Text = pCombobox.List(0)

End Sub

Private Sub Form_Unload(Cancel As Integer)
' -----------------------------------------------------------------------------
'
' -----------------------------------------------------------------------------
    form_Main.Show
    
End Sub

Private Sub menu_Print_Click()
' -----------------------------------------------------------------------------
'
' -----------------------------------------------------------------------------
    form_Main.CD_Save.ShowSave
    If form_Main.CD_Save.FileName = "" Then Exit Sub
    
    Open form_Main.CD_Save.FileName For Output As #1
    
    For j = 0 To 367
        cbName.ListIndex = j
        
        Print #1, "Name: " & cbName.Text & " [# " & Hex(txtNumber.Text - 1) & "]"
        Print #1, ""
        
        For i = 1 To ListAI.ListCount - 1
            Print #1, ListAI.List(i)
        Next i
        Print #1, ""
        
    Next j
    
    Close #1
    
    MsgBox "The text file has been generated", vbOKOnly, App.ProductName
    
End Sub
